diff --git a/doc/guides/nics/features.rst b/doc/guides/nics/features.rst
index cf82e9d57f..59beb47316 100644
--- a/doc/guides/nics/features.rst
+++ b/doc/guides/nics/features.rst
@@ -785,38 +785,20 @@ Multiprocess aware
 Driver can be used for primary-secondary process model.
 
 
-.. _nic_features_bsd_nic_uio:
+.. _nic_features_freebsd:
 
-BSD nic_uio
------------
+FreeBSD
+-------
 
-BSD ``nic_uio`` module supported.
+Supports running on FreeBSD.
 
 
-.. _nic_features_linux_uio:
+.. _nic_features_linux:
 
-Linux UIO
----------
+Linux
+-----
 
-Works with ``igb_uio`` kernel module.
-
-* **[provides] RTE_PMD_REGISTER_KMOD_DEP**: ``igb_uio``.
-
-.. _nic_features_linux_vfio:
-
-Linux VFIO
-----------
-
-Works with ``vfio-pci`` kernel module.
-
-* **[provides] RTE_PMD_REGISTER_KMOD_DEP**: ``vfio-pci``.
-
-.. _nic_features_other_kdrv:
-
-Other kdrv
-----------
-
-Kernel module other than above ones supported.
+Supports running on Linux.
 
 
 .. _nic_features_windows:
@@ -824,7 +806,7 @@ Kernel module other than above ones supported.
 Windows
 -------
 
-Support Windows.
+Supports running on Windows.
 
 
 .. _nic_features_armv7:
diff --git a/doc/guides/nics/features/ark.ini b/doc/guides/nics/features/ark.ini
index ec8a2b9983..5519984e39 100644
--- a/doc/guides/nics/features/ark.ini
+++ b/doc/guides/nics/features/ark.ini
@@ -10,6 +10,6 @@ Jumbo frame          = Y
 Scattered Rx         = Y
 Basic stats          = Y
 Stats per queue      = Y
-Linux UIO            = Y
+Linux                = Y
 x86-64               = Y
 Usage doc            = Y
diff --git a/doc/guides/nics/features/atlantic.ini b/doc/guides/nics/features/atlantic.ini
index 2bb8ecc017..d2ec33b217 100644
--- a/doc/guides/nics/features/atlantic.ini
+++ b/doc/guides/nics/features/atlantic.ini
@@ -32,7 +32,7 @@ Stats per queue      = Y
 FW version           = Y
 EEPROM dump          = Y
 Registers dump       = Y
-Linux UIO            = Y
+Linux                = Y
 ARMv8                = Y
 x86-32               = Y
 x86-64               = Y
diff --git a/doc/guides/nics/features/avp.ini b/doc/guides/nics/features/avp.ini
index ceb69939ba..9352c989fe 100644
--- a/doc/guides/nics/features/avp.ini
+++ b/doc/guides/nics/features/avp.ini
@@ -12,5 +12,5 @@ Unicast MAC filter   = Y
 VLAN offload         = Y
 Basic stats          = Y
 Stats per queue      = Y
-Linux UIO            = Y
+Linux                = Y
 x86-64               = Y
diff --git a/doc/guides/nics/features/axgbe.ini b/doc/guides/nics/features/axgbe.ini
index e2ad6efaf0..e11f440d73 100644
--- a/doc/guides/nics/features/axgbe.ini
+++ b/doc/guides/nics/features/axgbe.ini
@@ -19,6 +19,6 @@ L3 checksum offload  = Y
 L4 checksum offload  = Y
 Basic stats          = Y
 FW version           = Y
-Linux UIO            = Y
+Linux                = Y
 x86-32               = Y
 x86-64               = Y
diff --git a/doc/guides/nics/features/bnx2x.ini b/doc/guides/nics/features/bnx2x.ini
index e17bf60689..979bace466 100644
--- a/doc/guides/nics/features/bnx2x.ini
+++ b/doc/guides/nics/features/bnx2x.ini
@@ -13,6 +13,6 @@ Multicast MAC filter = Y
 SR-IOV               = Y
 Basic stats          = Y
 Extended stats       = Y
-Linux UIO            = Y
+Linux                = Y
 x86-64               = Y
 Usage doc            = Y
diff --git a/doc/guides/nics/features/bnxt.ini b/doc/guides/nics/features/bnxt.ini
index f8a7fd9a1f..79335783ec 100644
--- a/doc/guides/nics/features/bnxt.ini
+++ b/doc/guides/nics/features/bnxt.ini
@@ -45,9 +45,8 @@ FW version           = Y
 EEPROM dump          = Y
 LED                  = Y
 Multiprocess aware   = Y
-BSD nic_uio          = Y
-Linux UIO            = Y
-Linux VFIO           = Y
+FreeBSD              = Y
+Linux                = Y
 ARMv8                = Y
 x86-32               = Y
 x86-64               = Y
diff --git a/doc/guides/nics/features/cxgbe.ini b/doc/guides/nics/features/cxgbe.ini
index c03b53bd85..f91321504f 100644
--- a/doc/guides/nics/features/cxgbe.ini
+++ b/doc/guides/nics/features/cxgbe.ini
@@ -28,9 +28,8 @@ Stats per queue      = Y
 EEPROM dump          = Y
 Registers dump       = Y
 Multiprocess aware   = Y
-BSD nic_uio          = Y
-Linux UIO            = Y
-Linux VFIO           = Y
+FreeBSD              = Y
+Linux                = Y
 x86-32               = Y
 x86-64               = Y
 Usage doc            = Y
diff --git a/doc/guides/nics/features/cxgbevf.ini b/doc/guides/nics/features/cxgbevf.ini
index b41fc36551..303d6f2337 100644
--- a/doc/guides/nics/features/cxgbevf.ini
+++ b/doc/guides/nics/features/cxgbevf.ini
@@ -22,8 +22,7 @@ Packet type parsing  = Y
 Basic stats          = Y
 Stats per queue      = Y
 Multiprocess aware   = Y
-Linux UIO            = Y
-Linux VFIO           = Y
+Linux                = Y
 x86-32               = Y
 x86-64               = Y
 Usage doc            = Y
diff --git a/doc/guides/nics/features/default.ini b/doc/guides/nics/features/default.ini
index ee786d3d9a..8d89278479 100644
--- a/doc/guides/nics/features/default.ini
+++ b/doc/guides/nics/features/default.ini
@@ -65,10 +65,8 @@ Module EEPROM dump   =
 Registers dump       =
 LED                  =
 Multiprocess aware   =
-BSD nic_uio          =
-Linux UIO            =
-Linux VFIO           =
-Other kdrv           =
+FreeBSD              =
+Linux                =
 Windows              =
 ARMv7                =
 ARMv8                =
diff --git a/doc/guides/nics/features/dpaa2.ini b/doc/guides/nics/features/dpaa2.ini
index 878f03d40f..59bd1a2ced 100644
--- a/doc/guides/nics/features/dpaa2.ini
+++ b/doc/guides/nics/features/dpaa2.ini
@@ -28,6 +28,6 @@ Timestamp offload    = Y
 Basic stats          = Y
 Extended stats       = Y
 FW version           = Y
-Linux VFIO           = Y
+Linux                = Y
 ARMv8                = Y
 Usage doc            = Y
diff --git a/doc/guides/nics/features/e1000.ini b/doc/guides/nics/features/e1000.ini
index 51ca580f5f..7a224cc535 100644
--- a/doc/guides/nics/features/e1000.ini
+++ b/doc/guides/nics/features/e1000.ini
@@ -25,8 +25,7 @@ L4 checksum offload  = Y
 Rx descriptor status = Y
 Tx descriptor status = Y
 Basic stats          = Y
-BSD nic_uio          = Y
-Linux UIO            = Y
-Linux VFIO           = Y
+FreeBSD              = Y
+Linux                = Y
 x86-32               = Y
 x86-64               = Y
diff --git a/doc/guides/nics/features/ena.ini b/doc/guides/nics/features/ena.ini
index 7cd6d50f98..2595ff53f9 100644
--- a/doc/guides/nics/features/ena.ini
+++ b/doc/guides/nics/features/ena.ini
@@ -16,8 +16,7 @@ L3 checksum offload  = Y
 L4 checksum offload  = Y
 Basic stats          = Y
 Extended stats       = Y
-Linux UIO            = Y
-Linux VFIO           = Y
+Linux                = Y
 ARMv8                = Y
 x86-32               = Y
 x86-64               = Y
diff --git a/doc/guides/nics/features/enetc.ini b/doc/guides/nics/features/enetc.ini
index 39a520172a..2087bb973b 100644
--- a/doc/guides/nics/features/enetc.ini
+++ b/doc/guides/nics/features/enetc.ini
@@ -15,6 +15,6 @@ Queue start/stop     = Y
 CRC offload          = Y
 L3 checksum offload  = P
 L4 checksum offload  = P
-Linux VFIO           = Y
+Linux                = Y
 ARMv8                = Y
 Usage doc            = Y
diff --git a/doc/guides/nics/features/enic.ini b/doc/guides/nics/features/enic.ini
index 9ef8f5f939..16d6aabe47 100644
--- a/doc/guides/nics/features/enic.ini
+++ b/doc/guides/nics/features/enic.ini
@@ -34,9 +34,8 @@ Packet type parsing  = Y
 Basic stats          = Y
 FW version           = Y
 Multiprocess aware   = Y
-BSD nic_uio          = Y
-Linux UIO            = Y
-Linux VFIO           = Y
+FreeBSD              = Y
+Linux                = Y
 x86-32               = Y
 x86-64               = Y
 Usage doc            = Y
diff --git a/doc/guides/nics/features/fm10k.ini b/doc/guides/nics/features/fm10k.ini
index 0acdf0d339..1faa7ce59c 100644
--- a/doc/guides/nics/features/fm10k.ini
+++ b/doc/guides/nics/features/fm10k.ini
@@ -32,8 +32,7 @@ Basic stats          = Y
 Extended stats       = Y
 Stats per queue      = Y
 Multiprocess aware   = Y
-BSD nic_uio          = Y
-Linux UIO            = Y
-Linux VFIO           = Y
+FreeBSD              = Y
+Linux                = Y
 x86-32               = Y
 x86-64               = Y
diff --git a/doc/guides/nics/features/fm10k_vf.ini b/doc/guides/nics/features/fm10k_vf.ini
index 44b50faa13..c5f3161a2e 100644
--- a/doc/guides/nics/features/fm10k_vf.ini
+++ b/doc/guides/nics/features/fm10k_vf.ini
@@ -24,8 +24,7 @@ Basic stats          = Y
 Extended stats       = Y
 Stats per queue      = Y
 Multiprocess aware   = Y
-BSD nic_uio          = Y
-Linux UIO            = Y
-Linux VFIO           = Y
+FreeBSD              = Y
+Linux                = Y
 x86-32               = Y
 x86-64               = Y
diff --git a/doc/guides/nics/features/hinic.ini b/doc/guides/nics/features/hinic.ini
index 5be05d36fb..988a0ad574 100644
--- a/doc/guides/nics/features/hinic.ini
+++ b/doc/guides/nics/features/hinic.ini
@@ -36,7 +36,6 @@ Flow API             = Y
 Flow control         = Y
 FW version           = Y
 Multiprocess aware   = Y
-Linux UIO            = Y
-Linux VFIO           = Y
+Linux                = Y
 x86-64               = Y
 ARMv8                = Y
diff --git a/doc/guides/nics/features/hns3.ini b/doc/guides/nics/features/hns3.ini
index f0747e3f07..a46739678f 100644
--- a/doc/guides/nics/features/hns3.ini
+++ b/doc/guides/nics/features/hns3.ini
@@ -39,6 +39,5 @@ Stats per queue      = Y
 FW version           = Y
 Registers dump       = Y
 Multiprocess aware   = Y
-Linux UIO            = Y
-Linux VFIO           = Y
+Linux                = Y
 ARMv8                = Y
diff --git a/doc/guides/nics/features/hns3_vf.ini b/doc/guides/nics/features/hns3_vf.ini
index 3128b63414..99a0bf03b8 100644
--- a/doc/guides/nics/features/hns3_vf.ini
+++ b/doc/guides/nics/features/hns3_vf.ini
@@ -36,6 +36,5 @@ Extended stats       = Y
 Stats per queue      = Y
 Registers dump       = Y
 Multiprocess aware   = Y
-Linux UIO            = Y
-Linux VFIO           = Y
+Linux                = Y
 ARMv8                = Y
diff --git a/doc/guides/nics/features/i40e.ini b/doc/guides/nics/features/i40e.ini
index 2e89079f51..b0a5ef4244 100644
--- a/doc/guides/nics/features/i40e.ini
+++ b/doc/guides/nics/features/i40e.ini
@@ -45,9 +45,8 @@ Extended stats       = Y
 FW version           = Y
 Module EEPROM dump   = Y
 Multiprocess aware   = Y
-BSD nic_uio          = Y
-Linux UIO            = Y
-Linux VFIO           = Y
+FreeBSD              = Y
+Linux                = Y
 x86-32               = Y
 x86-64               = Y
 ARMv8                = Y
diff --git a/doc/guides/nics/features/i40e_vf.ini b/doc/guides/nics/features/i40e_vf.ini
index 4984a61773..bac1bb4344 100644
--- a/doc/guides/nics/features/i40e_vf.ini
+++ b/doc/guides/nics/features/i40e_vf.ini
@@ -33,8 +33,7 @@ Tx descriptor status = Y
 Basic stats          = Y
 Extended stats       = Y
 Multiprocess aware   = Y
-BSD nic_uio          = Y
-Linux UIO            = Y
-Linux VFIO           = Y
+FreeBSD              = Y
+Linux                = Y
 x86-32               = Y
 x86-64               = Y
diff --git a/doc/guides/nics/features/iavf.ini b/doc/guides/nics/features/iavf.ini
index 17f7928eb1..980680e568 100644
--- a/doc/guides/nics/features/iavf.ini
+++ b/doc/guides/nics/features/iavf.ini
@@ -30,8 +30,7 @@ Rx descriptor status = Y
 Tx descriptor status = Y
 Basic stats          = Y
 Multiprocess aware   = Y
-BSD nic_uio          = Y
-Linux UIO            = Y
-Linux VFIO           = Y
+FreeBSD              = Y
+Linux                = Y
 x86-32               = Y
 x86-64               = Y
diff --git a/doc/guides/nics/features/ice.ini b/doc/guides/nics/features/ice.ini
index 3ee1f6ea45..e30a7d2e57 100644
--- a/doc/guides/nics/features/ice.ini
+++ b/doc/guides/nics/features/ice.ini
@@ -38,8 +38,7 @@ Extended stats       = Y
 FW version           = Y
 Module EEPROM dump   = Y
 Multiprocess aware   = Y
-BSD nic_uio          = Y
-Linux UIO            = Y
-Linux VFIO           = Y
+FreeBSD              = Y
+Linux                = Y
 x86-32               = Y
 x86-64               = Y
diff --git a/doc/guides/nics/features/ice_dcf.ini b/doc/guides/nics/features/ice_dcf.ini
index e2b5659090..f4998152df 100644
--- a/doc/guides/nics/features/ice_dcf.ini
+++ b/doc/guides/nics/features/ice_dcf.ini
@@ -13,7 +13,6 @@ CRC offload          = Y
 L3 checksum offload  = P
 L4 checksum offload  = P
 Basic stats          = Y
-Linux UIO            = Y
-Linux VFIO           = Y
+Linux                = Y
 x86-32               = Y
 x86-64               = Y
diff --git a/doc/guides/nics/features/igb.ini b/doc/guides/nics/features/igb.ini
index 167c0cabe8..2925a8031d 100644
--- a/doc/guides/nics/features/igb.ini
+++ b/doc/guides/nics/features/igb.ini
@@ -40,8 +40,7 @@ FW version           = Y
 EEPROM dump          = Y
 Module EEPROM dump   = Y
 Registers dump       = Y
-BSD nic_uio          = Y
-Linux UIO            = Y
-Linux VFIO           = Y
+FreeBSD              = Y
+Linux                = Y
 x86-32               = Y
 x86-64               = Y
diff --git a/doc/guides/nics/features/igb_vf.ini b/doc/guides/nics/features/igb_vf.ini
index d9653234b5..07698f7660 100644
--- a/doc/guides/nics/features/igb_vf.ini
+++ b/doc/guides/nics/features/igb_vf.ini
@@ -23,8 +23,7 @@ Tx descriptor status = Y
 Basic stats          = Y
 Extended stats       = Y
 Registers dump       = Y
-BSD nic_uio          = Y
-Linux UIO            = Y
-Linux VFIO           = Y
+FreeBSD              = Y
+Linux                = Y
 x86-32               = Y
 x86-64               = Y
diff --git a/doc/guides/nics/features/igc.ini b/doc/guides/nics/features/igc.ini
index 09300eb36a..300d37e81a 100644
--- a/doc/guides/nics/features/igc.ini
+++ b/doc/guides/nics/features/igc.ini
@@ -33,6 +33,5 @@ RSS reta update      = Y
 VLAN filter          = Y
 VLAN offload         = Y
 Flow API             = P
-Linux UIO            = Y
-Linux VFIO           = Y
+Linux                = Y
 x86-64               = Y
diff --git a/doc/guides/nics/features/ionic.ini b/doc/guides/nics/features/ionic.ini
index 5e64aeb46e..330c71dd20 100644
--- a/doc/guides/nics/features/ionic.ini
+++ b/doc/guides/nics/features/ionic.ini
@@ -31,7 +31,6 @@ Basic stats          = Y
 Extended stats       = Y
 Stats per queue      = Y
 FW version           = Y
-Linux UIO            = Y
-Linux VFIO           = Y
+Linux                = Y
 x86-64               = Y
 Usage doc            = Y
diff --git a/doc/guides/nics/features/ipn3ke.ini b/doc/guides/nics/features/ipn3ke.ini
index 47a6526bec..82de553eb2 100644
--- a/doc/guides/nics/features/ipn3ke.ini
+++ b/doc/guides/nics/features/ipn3ke.ini
@@ -44,8 +44,7 @@ Extended stats       = Y
 FW version           = Y
 Module EEPROM dump   = Y
 Multiprocess aware   = Y
-BSD nic_uio          = Y
-Linux UIO            = Y
-Linux VFIO           = Y
+FreeBSD              = Y
+Linux                = Y
 x86-32               = Y
 x86-64               = Y
diff --git a/doc/guides/nics/features/ixgbe.ini b/doc/guides/nics/features/ixgbe.ini
index f817c93b85..c5e6e14aac 100644
--- a/doc/guides/nics/features/ixgbe.ini
+++ b/doc/guides/nics/features/ixgbe.ini
@@ -50,9 +50,8 @@ EEPROM dump          = Y
 Module EEPROM dump   = Y
 Registers dump       = Y
 Multiprocess aware   = Y
-BSD nic_uio          = Y
-Linux UIO            = Y
-Linux VFIO           = Y
+FreeBSD              = Y
+Linux                = Y
 ARMv8                = Y
 x86-32               = Y
 x86-64               = Y
diff --git a/doc/guides/nics/features/ixgbe_vf.ini b/doc/guides/nics/features/ixgbe_vf.ini
index b75d7089ab..7161e61f9a 100644
--- a/doc/guides/nics/features/ixgbe_vf.ini
+++ b/doc/guides/nics/features/ixgbe_vf.ini
@@ -33,9 +33,8 @@ Basic stats          = Y
 Extended stats       = Y
 Registers dump       = Y
 Multiprocess aware   = Y
-BSD nic_uio          = Y
-Linux UIO            = Y
-Linux VFIO           = Y
+FreeBSD              = Y
+Linux                = Y
 ARMv8                = Y
 x86-32               = Y
 x86-64               = Y
diff --git a/doc/guides/nics/features/liquidio.ini b/doc/guides/nics/features/liquidio.ini
index f628b764ba..100c7213e0 100644
--- a/doc/guides/nics/features/liquidio.ini
+++ b/doc/guides/nics/features/liquidio.ini
@@ -25,7 +25,6 @@ Inner L4 checksum    = Y
 Basic stats          = Y
 Extended stats       = Y
 Multiprocess aware   = Y
-Linux UIO            = Y
-Linux VFIO           = Y
+Linux                = Y
 x86-64               = Y
 Usage doc            = Y
diff --git a/doc/guides/nics/features/mlx4.ini b/doc/guides/nics/features/mlx4.ini
index 9b70089dfc..ebb9ccf767 100644
--- a/doc/guides/nics/features/mlx4.ini
+++ b/doc/guides/nics/features/mlx4.ini
@@ -33,7 +33,7 @@ Basic stats          = Y
 Stats per queue      = Y
 FW version           = Y
 Multiprocess aware   = Y
-Other kdrv           = Y
+Linux                = Y
 Power8               = Y
 x86-32               = Y
 x86-64               = Y
diff --git a/doc/guides/nics/features/mlx5.ini b/doc/guides/nics/features/mlx5.ini
index 9d14678b1e..b0aecb88e3 100644
--- a/doc/guides/nics/features/mlx5.ini
+++ b/doc/guides/nics/features/mlx5.ini
@@ -44,7 +44,7 @@ Stats per queue      = Y
 FW version           = Y
 Module EEPROM dump   = Y
 Multiprocess aware   = Y
-Other kdrv           = Y
+Linux                = Y
 Windows              = P
 ARMv8                = Y
 Power8               = Y
diff --git a/doc/guides/nics/features/netvsc.ini b/doc/guides/nics/features/netvsc.ini
index f5dc1e7846..de8c698184 100644
--- a/doc/guides/nics/features/netvsc.ini
+++ b/doc/guides/nics/features/netvsc.ini
@@ -15,7 +15,7 @@ Basic stats          = Y
 Stats per queue      = Y
 Extended stats       = Y
 Multiprocess aware   = Y
-Other kdrv           = Y
+Linux                = Y
 ARMv7                = Y
 ARMv8                = Y
 x86-32               = Y
diff --git a/doc/guides/nics/features/nfb.ini b/doc/guides/nics/features/nfb.ini
index 6174d65cc6..c77b592789 100644
--- a/doc/guides/nics/features/nfb.ini
+++ b/doc/guides/nics/features/nfb.ini
@@ -12,6 +12,6 @@ Allmulticast mode    = Y
 Basic stats          = Y
 Extended stats       = Y
 Stats per queue      = Y
-Other kdrv           = Y
+Linux                = Y
 x86-64               = Y
 Usage doc            = Y
diff --git a/doc/guides/nics/features/nfp.ini b/doc/guides/nics/features/nfp.ini
index 70297b0907..fee9dae878 100644
--- a/doc/guides/nics/features/nfp.ini
+++ b/doc/guides/nics/features/nfp.ini
@@ -22,8 +22,7 @@ L3 checksum offload  = Y
 L4 checksum offload  = Y
 Basic stats          = Y
 Stats per queue      = Y
-Linux UIO            = Y
-Linux VFIO           = Y
+Linux                = Y
 Multiprocess aware   = Y
 x86-64               = Y
 Usage doc            = Y
diff --git a/doc/guides/nics/features/octeontx.ini b/doc/guides/nics/features/octeontx.ini
index 8a95c216cd..d6fd610090 100644
--- a/doc/guides/nics/features/octeontx.ini
+++ b/doc/guides/nics/features/octeontx.ini
@@ -24,6 +24,6 @@ Inner L4 checksum    = Y
 Packet type parsing  = Y
 Flow control         = Y
 Basic stats          = Y
-Linux VFIO           = Y
+Linux                = Y
 ARMv8                = Y
 Usage doc            = Y
diff --git a/doc/guides/nics/features/octeontx2.ini b/doc/guides/nics/features/octeontx2.ini
index fb13517828..c0bcb8278e 100644
--- a/doc/guides/nics/features/octeontx2.ini
+++ b/doc/guides/nics/features/octeontx2.ini
@@ -51,6 +51,6 @@ Extended stats       = Y
 FW version           = Y
 Module EEPROM dump   = Y
 Registers dump       = Y
-Linux VFIO           = Y
+Linux                = Y
 ARMv8                = Y
 Usage doc            = Y
diff --git a/doc/guides/nics/features/octeontx2_vec.ini b/doc/guides/nics/features/octeontx2_vec.ini
index 66e233aba3..7025e140ad 100644
--- a/doc/guides/nics/features/octeontx2_vec.ini
+++ b/doc/guides/nics/features/octeontx2_vec.ini
@@ -45,6 +45,6 @@ Stats per queue      = Y
 FW version           = Y
 Module EEPROM dump   = Y
 Registers dump       = Y
-Linux VFIO           = Y
+Linux                = Y
 ARMv8                = Y
 Usage doc            = Y
diff --git a/doc/guides/nics/features/octeontx2_vf.ini b/doc/guides/nics/features/octeontx2_vf.ini
index c04c0e9061..7f5e5b8bba 100644
--- a/doc/guides/nics/features/octeontx2_vf.ini
+++ b/doc/guides/nics/features/octeontx2_vf.ini
@@ -42,6 +42,6 @@ Stats per queue      = Y
 FW version           = Y
 Module EEPROM dump   = Y
 Registers dump       = Y
-Linux VFIO           = Y
+Linux                = Y
 ARMv8                = Y
 Usage doc            = Y
diff --git a/doc/guides/nics/features/pfe.ini b/doc/guides/nics/features/pfe.ini
index 5b6a367d7b..a360dd40e0 100644
--- a/doc/guides/nics/features/pfe.ini
+++ b/doc/guides/nics/features/pfe.ini
@@ -12,6 +12,6 @@ Basic stats          = Y
 MTU update           = Y
 Promiscuous mode     = Y
 Allmulticast mode    = Y
-Linux VFIO           = Y
+Linux                = Y
 ARMv8                = Y
 Usage doc            = Y
diff --git a/doc/guides/nics/features/qede.ini b/doc/guides/nics/features/qede.ini
index 46fba8e6c0..852cecb3d3 100644
--- a/doc/guides/nics/features/qede.ini
+++ b/doc/guides/nics/features/qede.ini
@@ -34,8 +34,7 @@ Stats per queue      = Y
 Registers dump       = Y
 SR-IOV               = Y
 Multiprocess aware   = Y
-Linux UIO            = Y
-Linux VFIO           = Y
+Linux                = Y
 ARMv8                = Y
 x86-32               = Y
 x86-64               = Y
diff --git a/doc/guides/nics/features/qede_vf.ini b/doc/guides/nics/features/qede_vf.ini
index e796b31319..e71a3e5ac4 100644
--- a/doc/guides/nics/features/qede_vf.ini
+++ b/doc/guides/nics/features/qede_vf.ini
@@ -28,8 +28,7 @@ Basic stats          = Y
 Extended stats       = Y
 Stats per queue      = Y
 Multiprocess aware   = Y
-Linux UIO            = Y
-Linux VFIO           = Y
+Linux                = Y
 ARMv8                = Y
 x86-32               = Y
 x86-64               = Y
diff --git a/doc/guides/nics/features/sfc_efx.ini b/doc/guides/nics/features/sfc_efx.ini
index 213b6e1769..7e29568e5f 100644
--- a/doc/guides/nics/features/sfc_efx.ini
+++ b/doc/guides/nics/features/sfc_efx.ini
@@ -37,8 +37,7 @@ Basic stats          = Y
 Extended stats       = Y
 FW version           = Y
 Multiprocess aware   = Y
-BSD nic_uio          = Y
-Linux UIO            = Y
-Linux VFIO           = Y
+FreeBSD              = Y
+Linux                = Y
 ARMv8                = Y
 x86-64               = Y
diff --git a/doc/guides/nics/features/szedata2.ini b/doc/guides/nics/features/szedata2.ini
index a0e6f6e871..df021ffca7 100644
--- a/doc/guides/nics/features/szedata2.ini
+++ b/doc/guides/nics/features/szedata2.ini
@@ -13,6 +13,6 @@ Allmulticast mode    = Y
 Basic stats          = Y
 Extended stats       = Y
 Stats per queue      = Y
-Other kdrv           = Y
+Linux                = Y
 x86-64               = Y
 Usage doc            = Y
diff --git a/doc/guides/nics/features/tap.ini b/doc/guides/nics/features/tap.ini
index 519cad924d..be5e53dbe9 100644
--- a/doc/guides/nics/features/tap.ini
+++ b/doc/guides/nics/features/tap.ini
@@ -19,7 +19,7 @@ Multicast MAC filter = Y
 Unicast MAC filter   = Y
 Packet type parsing  = Y
 Flow control         = Y
-Other kdrv           = Y
+Linux                = Y
 ARMv7                = Y
 ARMv8                = Y
 Power8               = Y
diff --git a/doc/guides/nics/features/thunderx.ini b/doc/guides/nics/features/thunderx.ini
index 6268589716..add5428174 100644
--- a/doc/guides/nics/features/thunderx.ini
+++ b/doc/guides/nics/features/thunderx.ini
@@ -26,6 +26,6 @@ Basic stats          = Y
 Stats per queue      = Y
 Registers dump       = Y
 Multiprocess aware   = Y
-Linux VFIO           = Y
+Linux                = Y
 ARMv8                = Y
 Usage doc            = Y
diff --git a/doc/guides/nics/features/txgbe.ini b/doc/guides/nics/features/txgbe.ini
index bf24b73f72..a3fdee9f8a 100644
--- a/doc/guides/nics/features/txgbe.ini
+++ b/doc/guides/nics/features/txgbe.ini
@@ -48,8 +48,7 @@ EEPROM dump          = Y
 Module EEPROM dump   = Y
 Registers dump       = Y
 Multiprocess aware   = Y
-Linux UIO            = Y
-Linux VFIO           = Y
+Linux                = Y
 ARMv8                = Y
 x86-32               = Y
 x86-64               = Y
diff --git a/doc/guides/nics/features/virtio.ini b/doc/guides/nics/features/virtio.ini
index bbf9730318..48f6f393b1 100644
--- a/doc/guides/nics/features/virtio.ini
+++ b/doc/guides/nics/features/virtio.ini
@@ -19,9 +19,8 @@ Basic stats          = Y
 Stats per queue      = Y
 Extended stats       = P
 Multiprocess aware   = Y
-BSD nic_uio          = Y
-Linux UIO            = Y
-Linux VFIO           = Y
+FreeBSD              = Y
+Linux                = Y
 ARMv7                = Y
 ARMv8                = Y
 x86-32               = Y
diff --git a/doc/guides/nics/features/vmxnet3.ini b/doc/guides/nics/features/vmxnet3.ini
index 9a11513801..c74d7d5963 100644
--- a/doc/guides/nics/features/vmxnet3.ini
+++ b/doc/guides/nics/features/vmxnet3.ini
@@ -23,8 +23,7 @@ Packet type parsing  = Y
 Basic stats          = Y
 Extended stats       = Y
 Stats per queue      = Y
-Linux UIO            = Y
-Linux VFIO           = Y
+Linux                = Y
 x86-32               = Y
 x86-64               = Y
 Usage doc            = Y
diff --git a/doc/guides/vdpadevs/features/default.ini b/doc/guides/vdpadevs/features/default.ini
index 2c122a3865..ed16d0045b 100644
--- a/doc/guides/vdpadevs/features/default.ini
+++ b/doc/guides/vdpadevs/features/default.ini
@@ -38,9 +38,8 @@ proto reply ack      =
 proto host notifier  =
 proto pagefault      =
 queue statistics     =
-BSD nic_uio          =
-Linux VFIO           =
-Other kdrv           =
+FreeBSD              =
+Linux                =
 ARMv7                =
 ARMv8                =
 Power8               =
@@ -48,4 +47,4 @@ x86-32               =
 x86-64               =
 Usage doc            =
 Design doc           =
-Perf doc             =
\ No newline at end of file
+Perf doc             =
diff --git a/doc/guides/vdpadevs/features/mlx5.ini b/doc/guides/vdpadevs/features/mlx5.ini
index 990ef12dfc..f36c04dd28 100644
--- a/doc/guides/vdpadevs/features/mlx5.ini
+++ b/doc/guides/vdpadevs/features/mlx5.ini
@@ -19,7 +19,7 @@ proto mq             = Y
 proto log shmfd      = Y
 proto host notifier  = Y
 queue statistics     = Y
-Other kdrv           = Y
+Linux                = Y
 ARMv8                = Y
 Power8               = Y
 x86-32               = Y
diff --git a/doc/guides/vdpadevs/features_overview.rst b/doc/guides/vdpadevs/features_overview.rst
index 930bc878b9..991c0998a5 100644
--- a/doc/guides/vdpadevs/features_overview.rst
+++ b/doc/guides/vdpadevs/features_overview.rst
@@ -99,14 +99,11 @@ proto pagefault
 queue statistics
   Support virtio queue statistics query.
 
-BSD nic_uio
-  BSD ``nic_uio`` module supported.
+FreeBSD
+  Support FreeBSD.
 
-Linux VFIO
-  Works with ``vfio-pci`` kernel module.
-
-Other kdrv
-  Kernel module other than above ones supported.
+Linux
+  Support Linux.
 
 ARMv7
   Support armv7 architecture.